/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20180427 (64-bit version)(RM)
 * Copyright (c) 2000 - 2018 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-18-Pci8844.aml, Thu Jan  9 16:24:49 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000004BE (1214)
 *     Revision         0x01
 *     Checksum         0xD0
 *     OEM ID           "PCIRef"
 *     OEM Table ID     "Pci8844"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20061109 (537268489)
 */
DefinitionBlock ("", "SSDT", 1, "PCIRef", "Pci8844", 0x00001000)
{
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.LPCB.LNKA, UnknownObj)
    External (_SB_.PCI0.LPCB.LNKB, UnknownObj)
    External (_SB_.PCI0.LPCB.LNKC, UnknownObj)
    External (_SB_.PCI0.LPCB.LNKD, UnknownObj)
    External (_SB_.PCI0.P0P9.P9P2, DeviceObj)
    External (BPHP, FieldUnitObj)
    External (GPIC, IntObj)

    Scope (\_SB.PCI0)
    {
        Device (NRP5)
        {
            Name (_ADR, 0x00050000)  // _ADR: Address
            OperationRegion (PCTL, PCI_Config, 0x48, 0x04)
            Field (PCTL, ByteAcc, NoLock, Preserve)
            {
                Offset (0x01), 
                HPGE,   1, 
                Offset (0x02), 
                Offset (0x03), 
                Offset (0x04)
            }

            Method (_INI, 0, NotSerialized)  // _INI: Initialize
            {
                If (LNotEqual (\BPHP, 0x05))
                {
                    Store (0x01, HPGE)
                }
            }

            Method (_PRW, 0, NotSerialized)  // _PRW: Power Resources for Wake
            {
                Return (Package (0x02)
                {
                    0x09, 
                    0x04
                })
            }

            Method (_PRT, 0, NotSerialized)  // _PRT: PCI Routing Table
            {
                If (\GPIC)
                {
                    Return (Package (0x04)
                    {
                        Package (0x04)
                        {
                            0xFFFF, 
                            0x00, 
                            0x00, 
                            0x13
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x01, 
                            0x00, 
                            0x10
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x02, 
                            0x00, 
                            0x11
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x03, 
                            0x00, 
                            0x12
                        }
                    })
                }
                Else
                {
                    Return (Package (0x04)
                    {
                        Package (0x04)
                        {
                            0xFFFF, 
                            0x00, 
                            \_SB.PCI0.LPCB.LNKD, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x01, 
                            \_SB.PCI0.LPCB.LNKA, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x02, 
                            \_SB.PCI0.LPCB.LNKB, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x03, 
                            \_SB.PCI0.LPCB.LNKC, 
                            0x00
                        }
                    })
                }
            }

            Device (PXS1)
            {
                Name (_ADR, 0xFFFF)  // _ADR: Address
                Name (_SUN, 0x01)  // _SUN: Slot User Number
            }
        }

        Device (NRP1)
        {
            Name (_ADR, 0x00010000)  // _ADR: Address
            OperationRegion (PCTL, PCI_Config, 0x48, 0x04)
            Field (PCTL, ByteAcc, NoLock, Preserve)
            {
                Offset (0x01), 
                HPGE,   1, 
                Offset (0x02), 
                Offset (0x03), 
                Offset (0x04)
            }

            Method (_INI, 0, NotSerialized)  // _INI: Initialize
            {
                If (LNotEqual (BPHP, 0x05))
                {
                    Store (0x01, HPGE)
                }
            }

            Method (_PRW, 0, NotSerialized)  // _PRW: Power Resources for Wake
            {
                Return (Package (0x02)
                {
                    0x09, 
                    0x04
                })
            }

            Method (_PRT, 0, NotSerialized)  // _PRT: PCI Routing Table
            {
                If (\GPIC)
                {
                    Return (Package (0x04)
                    {
                        Package (0x04)
                        {
                            0xFFFF, 
                            0x00, 
                            0x00, 
                            0x12
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x01, 
                            0x00, 
                            0x13
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x02, 
                            0x00, 
                            0x10
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x03, 
                            0x00, 
                            0x11
                        }
                    })
                }
                Else
                {
                    Return (Package (0x04)
                    {
                        Package (0x04)
                        {
                            0xFFFF, 
                            0x00, 
                            \_SB.PCI0.LPCB.LNKC, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x01, 
                            \_SB.PCI0.LPCB.LNKD, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x02, 
                            \_SB.PCI0.LPCB.LNKA, 
                            0x00
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x03, 
                            \_SB.PCI0.LPCB.LNKB, 
                            0x00
                        }
                    })
                }
            }

            Device (PXS2)
            {
                Name (_ADR, 0xFFFF)  // _ADR: Address
                Name (_SUN, 0x02)  // _SUN: Slot User Number
            }
        }

        Scope (\_SB.PCI0.P0P9.P9P2)
        {
            Device (P2P3)
            {
                Name (_ADR, 0x00)  // _ADR: Address
                OperationRegion (PCTL, PCI_Config, 0x48, 0x04)
                Field (PCTL, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    HPGE,   1, 
                    Offset (0x02), 
                    Offset (0x03), 
                    Offset (0x04)
                }

                Method (_PRW, 0, NotSerialized)  // _PRW: Power Resources for Wake
                {
                    Return (Package (0x02)
                    {
                        0x09, 
                        0x04
                    })
                }

                Method (_PRT, 0, NotSerialized)  // _PRT: PCI Routing Table
                {
                    If (\GPIC)
                    {
                        Return (Package (0x04)
                        {
                            Package (0x04)
                            {
                                0xFFFF, 
                                0x00, 
                                0x00, 
                                0x10
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x01, 
                                0x00, 
                                0x11
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x02, 
                                0x00, 
                                0x12
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x03, 
                                0x00, 
                                0x13
                            }
                        })
                    }
                    Else
                    {
                        Return (Package (0x04)
                        {
                            Package (0x04)
                            {
                                0xFFFF, 
                                0x00, 
                                \_SB.PCI0.LPCB.LNKA, 
                                0x00
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x01, 
                                \_SB.PCI0.LPCB.LNKB, 
                                0x00
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x02, 
                                \_SB.PCI0.LPCB.LNKC, 
                                0x00
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x03, 
                                \_SB.PCI0.LPCB.LNKD, 
                                0x00
                            }
                        })
                    }
                }

                Device (PXS4)
                {
                    Name (_ADR, 0xFFFF)  // _ADR: Address
                    Name (_SUN, 0x04)  // _SUN: Slot User Number
                }
            }

            Device (P2P6)
            {
                Name (_ADR, 0x00010000)  // _ADR: Address
                OperationRegion (PCTL, PCI_Config, 0x48, 0x04)
                Field (PCTL, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    HPGE,   1, 
                    Offset (0x02), 
                    Offset (0x03), 
                    Offset (0x04)
                }

                Method (_PRT, 0, NotSerialized)  // _PRT: PCI Routing Table
                {
                    If (\GPIC)
                    {
                        Return (Package (0x04)
                        {
                            Package (0x04)
                            {
                                0xFFFF, 
                                0x00, 
                                0x00, 
                                0x11
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x01, 
                                0x00, 
                                0x12
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x02, 
                                0x00, 
                                0x13
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x03, 
                                0x00, 
                                0x10
                            }
                        })
                    }
                    Else
                    {
                        Return (Package (0x04)
                        {
                            Package (0x04)
                            {
                                0xFFFF, 
                                0x00, 
                                \_SB.PCI0.LPCB.LNKB, 
                                0x00
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x01, 
                                \_SB.PCI0.LPCB.LNKC, 
                                0x00
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x02, 
                                \_SB.PCI0.LPCB.LNKD, 
                                0x00
                            }, 

                            Package (0x04)
                            {
                                0xFFFF, 
                                0x03, 
                                \_SB.PCI0.LPCB.LNKA, 
                                0x00
                            }
                        })
                    }
                }

                Device (PXS3)
                {
                    Name (_ADR, 0xFFFF)  // _ADR: Address
                    Name (_SUN, 0x03)  // _SUN: Slot User Number
                    Notify (\_SB.PCI0.P0P9.P9P2.P2P6.PXS3, Zero)
                    
                }
            }
        }
    }
}

